package com.upyuns.platform.rs.website.controller.web;

import cn.hutool.core.util.StrUtil;
import com.github.wxiaoqi.security.admin.feign.UserFeign;
import com.github.wxiaoqi.security.admin.feign.rest.UserRestInterface;
import com.github.wxiaoqi.security.common.msg.ObjectRestResponse;
import com.github.wxiaoqi.security.common.rest.BaseController;
import com.github.wxiaoqi.security.common.util.AssertUtils;
import com.github.wxiaoqi.security.common.vo.PageDataVO;
import com.github.wxiaoqi.security.common.vo.PageParam;
import com.upyuns.platform.rs.datacenter.fegin.DatacenterFeign;
import com.upyuns.platform.rs.website.biz.CustomFormBiz;
import com.upyuns.platform.rs.website.entity.CustomForm;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;
import static com.github.wxiaoqi.security.common.constant.CommonConstants.SYS_FALSE;

@RestController
@RequestMapping("customForm/web")
public class CustomFormWebController extends BaseController<CustomFormBiz,CustomForm> implements UserRestInterface {

    @Autowired
    UserFeign userFeign;

    @Autowired
    DatacenterFeign datacenterFegin;

    @Override
    public UserFeign getUserFeign() {
        return userFeign;
    }

    @RequestMapping(value = "customIndustry",method = RequestMethod.POST)
    public ObjectRestResponse customIndustry(@RequestBody CustomForm entity) {
        if(StrUtil.isNotBlank(entity.getProvinceCode())) {
            entity.setProvinceName(datacenterFegin.queryByCode(entity.getProvinceCode()).getData().getName());
        }
        if(StrUtil.isNotBlank(entity.getCityCode())) {
            entity.setCityName(datacenterFegin.queryByCode(entity.getCityCode()).getData().getName());
        }
        if(StrUtil.isNotBlank(entity.getAreaCode())) {
            entity.setAreaName(datacenterFegin.queryByCode(entity.getAreaCode()).getData().getName());
        }
        entity.setUserId(getAppUser().getUserid());
        baseBiz.insertSelective(entity);
        return ObjectRestResponse.succ();
    }

    @RequestMapping(value = "customImgStorage",method = RequestMethod.POST)
    public ObjectRestResponse customImgStorage(@RequestBody CustomForm entity) {
        if(StrUtil.isNotBlank(entity.getProvinceCode())) {
            entity.setProvinceName(datacenterFegin.queryByCode(entity.getProvinceCode()).getData().getName());
        }
        if(StrUtil.isNotBlank(entity.getCityCode())) {
            entity.setCityName(datacenterFegin.queryByCode(entity.getCityCode()).getData().getName());
        }
        if(StrUtil.isNotBlank(entity.getAreaCode())) {
            entity.setAreaName(datacenterFegin.queryByCode(entity.getAreaCode()).getData().getName());
        }
        entity.setUserId(getAppUser().getUserid());
        baseBiz.insertSelective(entity);
        return ObjectRestResponse.succ();
    }

    @RequestMapping(value = "customImageData",method = RequestMethod.POST)
    public ObjectRestResponse customImageData(@RequestBody CustomForm entity) {
        if(StrUtil.isNotBlank(entity.getProvinceCode())) {
            entity.setProvinceName(datacenterFegin.queryByCode(entity.getProvinceCode()).getData().getName());
        }
        if(StrUtil.isNotBlank(entity.getCityCode())) {
            entity.setCityName(datacenterFegin.queryByCode(entity.getCityCode()).getData().getName());
        }
        if(StrUtil.isNotBlank(entity.getAreaCode())) {
            entity.setAreaName(datacenterFegin.queryByCode(entity.getAreaCode()).getData().getName());
        }
        entity.setUserId(getAppUser().getUserid());
        baseBiz.insertSelective(entity);
        return ObjectRestResponse.succ();
    }

    @RequestMapping(value = "myCustoms",method = RequestMethod.GET)
    public ObjectRestResponse<PageDataVO<CustomForm>> myCustoms(PageParam dto) {

        return ObjectRestResponse.succ(PageDataVO.pageInfo(dto.initQuery(), () -> baseBiz.selectByWeekend(w -> {
            w.andEqualTo(CustomForm::getUserId, getAppUser().getUserid());
            w.andEqualTo(CustomForm::getIsDel, SYS_FALSE);
            return w;
        }, " crt_time desc")));
    }


}